#include <sourcemod>
#include <sdktools>
#include <sdkhooks>

public Plugin myinfo = 
{
	name = "Fortnite player hits",
	author = "GAMMA CASE",
	description = "Shows damage like in fortnite",
	version = "1.0.0",
	url = "http://steamcommunity.com/id/_GAMMACASE_/"
}

#define x 0
#define y 1
#define z 2

bool g_bIsFired[MAXPLAYERS + 1],
	g_bIsCrit[MAXPLAYERS + 1][MAXPLAYERS + 1];
int g_iTotalSGDamage[MAXPLAYERS + 1][MAXPLAYERS + 1];
float g_fPlayerPosLate[MAXPLAYERS + 1][3];

ConVar g_cvAllowForBots;

enum HitGroup
{
	HITGROUP_GENERIC = 0,
	HITGROUP_HEAD,
	HITGROUP_CHEST,
	HITGROUP_STOMACH,
	HITGROUP_LEFTARM,
	HITGROUP_RIGHTARM,
	HITGROUP_LEFTLEG,
	HITGROUP_RIGHTLEG
}

public void OnPluginStart()
{
	g_cvAllowForBots = CreateConVar("fortnite_hits_allowforbots", "1", "Allow bots to create hit particles (Only will be visible when spectating a bot)", FCVAR_NONE, true, 0.0, true, 1.0);
	AutoExecConfig();
	
	HookEvent("player_hurt", PlayerHurt_Event);
}

public void OnMapStart()
{
	PrecacheGeneric("particles/gammacase/hit_nums.pcf", true);
	AddFileToDownloadsTable("particles/gammacase/hit_nums.pcf");
	AddFileToDownloadsTable("materials/gammacase/fortnite/hitnums/nums_bw.vmt");
	AddFileToDownloadsTable("materials/gammacase/fortnite/hitnums/nums_bw.vtf");
}

public void PlayerHurt_Event(Event event, const char[] name, bool dontBroadcast)
{
	static int attacker, client, damage;
	static HitGroup hitgroup;
	static char sWeapon[32];
	
	attacker = GetClientOfUserId(event.GetInt("attacker")),
	client = GetClientOfUserId(event.GetInt("userid")),
	damage = event.GetInt("dmg_health");
	hitgroup = view_as<HitGroup>(event.GetInt("hitgroup"));
	event.GetString("weapon", sWeapon, sizeof(sWeapon));
	
	if(attacker == client || attacker == 0 || client == 0)
		return;
	
	if(!g_cvAllowForBots.BoolValue && IsFakeClient(attacker))
		return;
	
	if(StrEqual(sWeapon, "xm1014") || StrEqual(sWeapon, "nova") || StrEqual(sWeapon, "mag7") || StrEqual(sWeapon, "sawedoff"))
	{
		if(!g_bIsFired[attacker])
		{
			CreateTimer(0.1, TimerHit_CallBack, GetClientUserId(attacker), TIMER_FLAG_NO_MAPCHANGE);
			
			g_bIsFired[attacker] = true;
			g_iTotalSGDamage[attacker][client] = damage;
		}
		else
			g_iTotalSGDamage[attacker][client] += damage;
		
		if(hitgroup == HITGROUP_HEAD)
			g_bIsCrit[attacker][client] = true;
		GetClientAbsOrigin(client, g_fPlayerPosLate[client]);
	}
	else
		ShowPRTDamage(attacker, client, damage, (hitgroup == HITGROUP_HEAD));
}

public Action TimerHit_CallBack(Handle timer, int userid)
{
	static int client;
	client = GetClientOfUserId(userid);
	
	if(client == 0)
		return Plugin_Stop;
	
	g_bIsFired[client] = false;
	for(int i = 1; i <= MaxClients; i++)
	{
		if(!IsValidClient(i, false))
			continue;
		
		if(g_iTotalSGDamage[client][i] != 0)
		{
			ShowPRTDamage(client, i, g_iTotalSGDamage[client][i], g_bIsCrit[client][i], true);
			g_iTotalSGDamage[client][i] = 0;
			g_bIsCrit[client][i] = false;
		}
	}
	
	return Plugin_Continue;
}

stock void ShowPRTDamage(int attacker, int client, int damage, bool crit, bool late = false)
{
	if(!IsValidClient(client, false))
		return;
	
	if(!IsValidClient(attacker, false))
		return;
	
	static float pos[3], pos2[3], ang[3], fwd[3], right[3], temppos[3], dist, d;
	static int ent, l, count, dmgnums[8];
	static char buff[16];
	
	count = 0;
	
	while(damage > 0)
	{
		dmgnums[count++] = damage % 10;
		damage /= 10;
	}
	
	GetClientEyeAngles(attacker, ang);
	GetClientAbsOrigin(attacker, pos2);
	
	if(late)
		pos = g_fPlayerPosLate[client];
	else
		GetClientAbsOrigin(client, pos);
	
	GetAngleVectors(ang, fwd, right, NULL_VECTOR);
	
	l = RoundToCeil(float(count)/2.0);
	
	dist = GetVectorDistance(pos2, pos);
	if(dist > 700.0)
		d = dist / 700.0 * 6.0;
	else
		d = 6.0;
	
	pos[x] += right[x] * d * l * GetRandomFloat(-0.5, 1.0);
	pos[y] += right[y] * d * l * GetRandomFloat(-0.5, 1.0);
	if(GetEntProp(client, Prop_Send, "m_bDucked"))
		if(crit)
			pos[z] += 45.0 + GetRandomFloat(0.0, 10.0);
		else
			pos[z] += 25.0 + GetRandomFloat(0.0, 20.0);
	else
		if(crit)
			pos[z] += 60.0 + GetRandomFloat(0.0, 10.0);
		else
			pos[z] += 35.0 + GetRandomFloat(0.0, 20.0);
	
	for(int i = count - 1; i >= 0; i--)
	{
		temppos = pos;
		
		temppos[x] -= fwd[x] * 50 + right[x] * d * l;
		temppos[y] -= fwd[y] * 50 + right[y] * d * l;
		
		ent = CreateEntityByName("info_particle_system");
		if(ent == -1)
			SetFailState("Error creating \"info_particle_system\" entity!");
		
		TeleportEntity(ent, temppos, ang, NULL_VECTOR);
		
		FormatEx(buff, sizeof(buff), "%s_num%i_f%s", (crit ? "crit" : "def"), dmgnums[i], (l-- > 0 ? "l" : "r"));
		
		DispatchKeyValue(ent, "effect_name", buff);
		DispatchKeyValue(ent, "start_active", "1");
		DispatchSpawn(ent);
		ActivateEntity(ent);
		
		SetEntPropEnt(ent, Prop_Send, "m_hOwnerEntity", attacker);
		SDKHook(ent, SDKHook_SetTransmit, SetTransmit_Hook);
		
		SetVariantString("OnUser1 !self:kill::3:-1");
		AcceptEntityInput(ent, "AddOutput");
		AcceptEntityInput(ent, "FireUser1");
	}
}

public Action SetTransmit_Hook(int entity, int client)
{
	if(GetEdictFlags(entity) & FL_EDICT_ALWAYS)
		SetEdictFlags(entity, (GetEdictFlags(entity) ^ FL_EDICT_ALWAYS));
	
	if(GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity") == client || (GetEntPropEnt(client, Prop_Send, "m_hObserverTarget") == GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity") && (GetEntProp(client, Prop_Send, "m_iObserverMode") == 4 || GetEntProp(client, Prop_Send, "m_iObserverMode") == 5)))
		return Plugin_Continue;
	
	return Plugin_Stop;
}

stock bool IsValidClient(int client, bool botcheck = true)
{
	return (1 <= client && client <= MaxClients && IsClientConnected(client) && IsClientInGame(client) && (botcheck ? !IsFakeClient(client) : true)); 
}